/*
 * ccdownload.c - get bytes from CC1 over serial port
 * 
 * Copyright (C) 2003 Chris Ruehl <ruehlc@wiesbaden.vistec.net>
 * original code-parts from Diman Todorov
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *  
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 * 
 * ----------------------------------------------------------- 
 *  who | date | Comment
 * -----+------+----------------------------------------------
 */

#include <stdio.h>   /* Standard input/output definitions */
#include <stdlib.h>   /* Standard input/output definitions */
#include <string.h>  /* String function definitions */
#include <unistd.h>  /* UNIX standard function definitions */
#include <fcntl.h>   /* File control definitions */
#include <errno.h>   /* Error number definitions */
#include <termios.h> /* POSIX terminal control definitions */
#include "serial.h" 

int getprog(int);

int getprog(int fd)
{
#define GETBS 256
    char chout = 'x';
    char sendc[GETBS];
    memset(sendc,0,sizeof(char)*GETBS);
    
    tcflush(fd, TCIOFLUSH);
    sendc[0] = 0x03;  //dump program
    write(fd, sendc, sizeof(char)); 
    printf("dumping...\n");

    while (read(fd,&chout,sizeof(chout))) {
       if (chout == -1 ) break;
       printf("%d ", chout);
    }
    printf("\n");
    return 0;    
}

void ussage (char *n) 
{
	fprintf(stderr,"Usage: %s -d <tty device>\n", n);
	exit(1);
}

int main(int argc, char **argv)
{
    int mainfd = 0;
    int opt;
    char *devname = NULL;
    
    if(argc < 2)
    {
	ussage(argv[0]);	
    }
        
    while(1)
    {        
		opt = getopt(argc, argv, "d:");
		if(opt == -1)
			break;
		switch(opt)
		{
			case 'd':
				devname = optarg;
				break;  	  
			default:
				ussage(argv[0]);
				break;
		}
	}
    
    mainfd = open_port(devname);
    
    if(mainfd < 0)
    {
   	printf("failed opening %s\n", devname);
	return 1;
    }
    printf("opened device successfully\n");
    
    if(initmc(mainfd) < 0)
    {
	printf("failed mc init\n");
	return 1;
    }
    printf("intialzied micro controller successfully\n");
    
    if(getprog(mainfd) == 1)
    {
	printf("faied getting program\n");
	return 1;
    }     
    printf("got program successfully\n");
    close(mainfd);

    return 0;
}
